/*
 * service.cpp
 *
 *  Created on: Mar 22, 2015
 *      Author: ilazar
 */

#include "domain.h"
#include "service.h"
#include <algorithm>

namespace Todo {

const Task& TodoManager::create_task(const string& text) const throw (logic_error, runtime_error) {
	debug("const Task& TodoManager::create_task(const string& text) const");
	Task* task = new Task(text, ACTIVE);
	if (task->is_valid()) {
		_task_repository.save(*task); // save task; this operation may throw runtime_errors due to I/O errors
		_tasks->push_back(*task);
	} else { // operation will fail due to invalid data
		delete task;
		throw logic_error("Invalid data");
	}
	return *task;
}

const list<Task>& TodoManager::get_tasks() throw (runtime_error) {
	debug("const list<Task>& TodoManager::get_tasks() const");
	_tasks->sort(task_comparator);
	return *_tasks;
}

}
